# bigip_ssl_certificate – Import/Delete certificates from BIG-IP

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- This module will import/delete SSL certificates on BIG-IP LTM. Certificates can be imported from certificate and key files on the local disk, in PEM format.

## Requirements

The below requirements are needed on the host that executes this module.

- BIG-IP >= v12

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
content string |  | Sets the contents of a certificate directly to the specified value. This is used with lookup plugins or for anything with formatting or `content` must be provided when `state` is `present`. aliases: cert_content
issuer_cert string added in 2.5 |  | Issuer certificate used for OCSP monitoring. This parameter is only valid on versions of BIG-IP 13.0.0 or above.
name string / required |  | SSL Certificate Name. This is the cert name used when importing a certificate into the F5. It also determines the filenames of the objects on the LTM.
partition string added in 2.5 | Default: "Common" | Device partition to manage resources on.
provider dictionary added in 2.5 |  | A dict object containing connection details.
| auth_provider string |  | Configures the auth provider for to obtain authentication tokens from the remote device. This option is really used when working with BIG-IQ devices.
| password string / required |  | The password for the user account used to connect to the BIG-IP. You may omit this option by setting the environment variable `F5_PASSWORD`. aliases: pass, pwd
| server string / required |  | The BIG-IP host. You may omit this option by setting the environment variable `F5_SERVER`.
| server_port integer | Default: 443 | The BIG-IP server port. You may omit this option by setting the environment variable `F5_SERVER_PORT`.
| ssh_keyfile path |  | Specifies the SSH keyfile to use to authenticate the connection to the remote device. This argument is only used for cli transports. You may omit this option by setting the environment variable `ANSIBLE_NET_SSH_KEYFILE`.
| timeout integer |  | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.

transport
string

Choices:
- cli
- rest ←

Configures the transport connection to use when connecting to the remote device.

| user string / required |  | The username to connect to the BIG-IP with. This user must have administrative privileges on the device. You may omit this option by setting the environment variable `F5_USER`.

validate_certs
boolean

Choices:
- no
- yes ←

If `no`, SSL certificates are not validated. Use this only on personally controlled sites using self-signed certificates.
You may omit this option by setting the environment variable `F5_VALIDATE_CERTS`.

state
string

Choices:
- present ←
- absent

Certificate state. This determines if the provided certificate and key is to be made `present` on the device or `absent`.

## Notes

Note

- This module does not behave like other modules that you might include in roles where referencing files or templates first looks in the role’s files or templates directory. To have it behave that way, use the Ansible file or template lookup (see Examples). The lookups behave as expected in a role context.
- For more information on using Ansible to manage F5 Networks devices see https://www.ansible.com/integrations/networks/f5.
- Requires BIG-IP software version >= 12.
- The F5 modules only manipulate the running configuration of the F5 product. To ensure that BIG-IP specific configuration persists to disk, be sure to include at least one task that uses the bigip_config module to save the running configuration. Refer to the module’s documentation for the correct usage of the module to save your running configuration.

## Examples

    - name: Use a file lookup to import PEM Certificate
      bigip_ssl_certificate:
        name: certificate-name
        state: present
        content: "{{ lookup('file', '/path/to/cert.crt') }}"
        provider:
          server: lb.mydomain.com
          user: admin
          password: secret
      delegate_to: localhost

    - name: Use a file lookup to import CA certificate chain
      bigip_ssl_certificate:
        name: ca-chain-name
        state: present
        content: "{{ lookup('file', '/path/to/ca-chain.crt') }}"
        provider:
          server: lb.mydomain.com
          user: admin
          password: secret
      delegate_to: localhost

    - name: Delete Certificate
      bigip_ssl_certificate:
        name: certificate-name
        state: absent
        provider:
          server: lb.mydomain.com
          user: admin
          password: secret
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
cert_name string | created | The name of the certificate that the user provided Sample: cert1
checksum string | changed and created | SHA1 checksum of the cert that was provided. Sample: f7ff9e8b7bb2e09b70935a5d785e0cc5d9d0abf0
filename string | created | The name of the SSL certificate. Sample: cert1.crt
source_path string | created | Path on BIG-IP where the source of the certificate is stored. Sample: /var/config/rest/downloads/cert1.crt

## Status

- This module is guaranteed to have backward compatible interface changes going forward. [stableinterface]
- This module is maintained by an Ansible Partner. [certified]

### Authors

- Tim Rupp (@caphrim007)
- Wojciech Wypior (@wojtek0806)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.